/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.storage.convert.DateConverter;
import com.flamesgroup.storage.convert.IccidConverter;
import com.flamesgroup.storage.convert.SmsDeliveryStatusesConverter;
import com.flamesgroup.storage.convert.SmsEncodingConverter;
import com.flamesgroup.storage.convert.SmsMessageClassClassConverter;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.SentSmsRecord;
import com.flamesgroup.unit.ICCID;
import com.flamesgroup.unit.sms.DeliveryStatuses;
import com.flamesgroup.unit.sms.SMSEncoding;
import com.flamesgroup.unit.sms.SMSMessageClass;

import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.UUID;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class SentSms extends TableImpl<SentSmsRecord> {

	private static final long serialVersionUID = 91098199;

	/**
	 * The reference instance of <code>public.sent_sms</code>
	 */
	public static final SentSms SENT_SMS = new SentSms();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<SentSmsRecord> getRecordType() {
		return SentSmsRecord.class;
	}

	/**
	 * The column <code>public.sent_sms.id</code>.
	 */
	public final TableField<SentSmsRecord, Integer> ID = createField("id", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sent_sms.iccid</code>.
	 */
	public final TableField<SentSmsRecord, ICCID> ICCID = createField("iccid", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "", new IccidConverter());

	/**
	 * The column <code>public.sent_sms.sms_id</code>.
	 */
	public final TableField<SentSmsRecord, UUID> SMS_ID = createField("sms_id", org.jooq.impl.SQLDataType.UUID, this, "");

	/**
	 * The column <code>public.sent_sms.sms_center_number</code>.
	 */
	public final TableField<SentSmsRecord, String> SMS_CENTER_NUMBER = createField("sms_center_number", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * The column <code>public.sent_sms.recipient_phone_number</code>.
	 */
	public final TableField<SentSmsRecord, String> RECIPIENT_PHONE_NUMBER = createField("recipient_phone_number", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.sent_sms.message</code>.
	 */
	public final TableField<SentSmsRecord, String> MESSAGE = createField("message", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.sent_sms.message_class</code>.
	 */
	public final TableField<SentSmsRecord, SMSMessageClass> MESSAGE_CLASS = createField("message_class", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "", new SmsMessageClassClassConverter());

	/**
	 * The column <code>public.sent_sms.encoding</code>.
	 */
	public final TableField<SentSmsRecord, SMSEncoding> ENCODING = createField("encoding", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "", new SmsEncodingConverter());

	/**
	 * The column <code>public.sent_sms.sender_time</code>.
	 */
	public final TableField<SentSmsRecord, Date> SENDER_TIME = createField("sender_time", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false).defaulted(true), this, "", new DateConverter());

	/**
	 * The column <code>public.sent_sms.reference_number</code>.
	 */
	public final TableField<SentSmsRecord, Integer> REFERENCE_NUMBER = createField("reference_number", org.jooq.impl.SQLDataType.INTEGER, this, "");

	/**
	 * The column <code>public.sent_sms.number_of_sms_part</code>.
	 */
	public final TableField<SentSmsRecord, Integer> NUMBER_OF_SMS_PART = createField("number_of_sms_part", org.jooq.impl.SQLDataType.INTEGER, this, "");

	/**
	 * The column <code>public.sent_sms.count_of_sms_parts</code>.
	 */
	public final TableField<SentSmsRecord, Integer> COUNT_OF_SMS_PARTS = createField("count_of_sms_parts", org.jooq.impl.SQLDataType.INTEGER, this, "");

	/**
	 * The column <code>public.sent_sms.receipt_requested</code>.
	 */
	public final TableField<SentSmsRecord, Boolean> RECEIPT_REQUESTED = createField("receipt_requested", org.jooq.impl.SQLDataType.BOOLEAN.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sent_sms.delivery_status</code>.
	 */
	public final TableField<SentSmsRecord, DeliveryStatuses> DELIVERY_STATUS = createField("delivery_status", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "", new SmsDeliveryStatusesConverter());

	/**
	 * Create a <code>public.sent_sms</code> table reference
	 */
	public SentSms() {
		this("sent_sms", null);
	}

	/**
	 * Create an aliased <code>public.sent_sms</code> table reference
	 */
	public SentSms(String alias) {
		this(alias, SENT_SMS);
	}

	private SentSms(String alias, Table<SentSmsRecord> aliased) {
		this(alias, aliased, null);
	}

	private SentSms(String alias, Table<SentSmsRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<SentSmsRecord, Integer> getIdentity() {
		return Keys.IDENTITY_SENT_SMS;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<SentSmsRecord> getPrimaryKey() {
		return Keys.SENT_SMS_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<SentSmsRecord>> getKeys() {
		return Arrays.<UniqueKey<SentSmsRecord>>asList(Keys.SENT_SMS_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SentSms as(String alias) {
		return new SentSms(alias, this);
	}

	/**
	 * Rename this table
	 */
	public SentSms rename(String name) {
		return new SentSms(name, null);
	}
}
